(*
 * Test question 9
 *)

open Question9

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let cycle =
    let c = ref 0 in
      function () -> c := !c + 1; !c
  in
  let rec new_tree () =
    if (cycle() > 512 || ((cycle() mod 10) <> 0 && Random.bool ())) then
      Vide
    else
      Noeud ({cle = Random.int 20 ; fg = new_tree () ; fd = new_tree () })
  in
  let rec print_tree = function
      Vide -> Printf.printf "()"
    | Noeud r ->
	Printf.printf "N(%i, " r.cle;
	print_tree r.fg ;
	Printf.printf ", " ;
	print_tree r.fd ;
	Printf.printf ")"
  in
  let usage = "Prog TP: question 9\nquestion9 graine" in
    Arg.parse (Arg.align []) anonfun usage ;
    ( try
	match get_liste () with
	  | seed::_ ->
	      Random.init seed;
	      let t = new_tree () in
		print_tree t;
		Printf.printf "\nHauteur = %d\n" (hauteur t);
		exit 0
	  | _ ->
	      Arg.usage (Arg.align []) usage ;
	      exit 1
      with
	  Invalid_argument("Mauvaises bornes.") ->
	    Printf.fprintf stderr "Mauvaises bornes.\n";
	    exit 3
    )
